<?php
/*	$Id: processskin.php,v 1.0 2006/03/03 14:31:55 fred Exp $	*/

function print_param($param, $processed) {
global $debugskin;
	if (!$debugskin)
		return;
	foreach ($param as $k => $v)
		if (!in_array($k, $processed)) echo "$param[NAME]: $k=\"$v\" ";
}

function ProcessAParameter($param, $whichone, $type, $default) {
	if (!isset($param[$whichone]))
		return($default);
	if ($type == 'bool') {
		$param[$whichone] = trim($param[$whichone]);
		$retval = false;
		if (strcasecmp($param[$whichone], 'yes') == 0 ||
		    strcasecmp($param[$whichone], 'true') == 0 ||
		    strcasecmp($param[$whichone], 'y') == 0 ||
		    strcasecmp($param[$whichone], 't') == 0)
			$retval = true;
	}
	else if ($type == 'int') {
		$retval = trim($param[$whichone]);
		if (!is_numeric($retval))
			$retval = $default;
	}
	else {
		$retval = $param[$whichone];
	}
	return($retval);
}

function title($param) {
global $dvd, $titledesc;
	$showdesc = ProcessAParameter($param, 'SHOWDESC', 'bool', true);
	$showtitle = ProcessAParameter($param, 'SHOWTITLE', 'bool', true);
	print_param($param, array('NAME','SHOWDESC','SHOWTITLE'));

	$ret = '';
	if ($showtitle && $showdesc) {
		$ret = $dvd['title'];
		if ($dvd['description'] != '') {
			switch ($titledesc) {
			case 1:
				$ret .= " ($dvd[description])";
				break;
			case 2:
				$ret .= ": $dvd[description]";
				break;
			case 3:
				$ret .= " - $dvd[description]";
				break;
			}
		}
	}
	else if ($showtitle) {
		$ret = $dvd['title'];
	}
	else if ($showdesc) {
		$ret = $dvd['description'];
	}
	return($ret);
}
function original_title($param) {
global $dvd, $titledesc;
	$usetitleifblank = ProcessAParameter($param, 'USETITLEIFBLANK', 'bool', true);
	$showdesc = ProcessAParameter($param, 'SHOWDESC', 'bool', true);
	print_param($param,array('NAME','USETITLEIFBLANK','SHOWDESC'));

	$ret = $dvd['originaltitle'];
	if ($ret == '' && $usetitleifblank)
		$ret = $dvd['title'];
	if ($ret != '' && $showdesc) {
		if ($dvd['description'] != '') {
			switch ($titledesc) {
			case 1:
				$ret .= " ($dvd[description])";
				break;
			case 2:
				$ret .= ": $dvd[description]";
				break;
			case 3:
				$ret .= " - $dvd[description]";
				break;
			}
		}
	}
	return($ret);
}
function ownership($param) {
global $dvd, $lang;
	$ifowned = ProcessAParameter($param, 'IFOWNED', 'string', $lang['OWNED']);
	$ifordered = ProcessAParameter($param, 'IFORDERED', 'string', $lang['ORDERED']);
	$ifwishlist = ProcessAParameter($param, 'IFWISHLIST', 'string', $lang['WISHLIST']);
	print_param($param, array('NAME','IFOWNED','IFORDERED','IFWISHLIST'));

	$ret = '';
	switch ($dvd['collectiontype']) {
	case 'owned':
		$ret = $ifowned;
		break;
	case 'ordered':
		$ret = $ifordered;
		break;
	case 'wishlist':
		$ret = $ifwishlist;
		break;
	}
	return($ret);
}
function loandue($param) {
// DVDPro BUG - ifoverdue seems broken ... it displays if _not_ overdue
global $dvd, $lang;
	$ifoverdue = ProcessAParameter($param, 'IFOVERDUE', 'string', '');
	print_param($param, array('NAME','IFOVERDUE'));

	if ($dvd['loandue'] == 0)
		return('');

	$late = (($dvd['loandue'] - time()) < 0);
	if ($ifoverdue == '') {
		$ret = strftime($lang['SKINDATEFORMAT'], $dvd['loandue']);
	}
	else {
		if ($late)
			$ret = '';
		else
			$ret = $ifoverdue;
	}
	return($ret);
}
function loanedto($param) {
global $dvd;
	$ifloaned = ProcessAParameter($param, 'IFLOANED', 'string', '');
	$ifnotloaned = ProcessAParameter($param, 'IFNOTLOANED', 'string', '');
	print_param($param, array('NAME','IFLOANED','IFNOTLOANED'));

	if ($dvd['loaninfo'] == '') {
		$ret = $ifnotloaned;
	}
	else {
		$ret = $dvd['loaninfo'];
		if ($ifloaned != '')
			$ret = $ifloaned;
	}
	return($ret);
}
function sorttitle($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = $dvd['sorttitle'];
	return($ret);
}
function review($param) {
global $dvd, $reviewgraph;
	$width = ProcessAParameter($param, 'WIDTH', 'int', 100);
	$height = ProcessAParameter($param, 'HEIGHT', 'int', 20);
	$bgcolor = ProcessAParameter($param, 'BGCOLOR', 'string', '');
	print_param($param, array('NAME','WIDTH','HEIGHT','BGCOLOR'));
	return(DrawAReviewGraph($dvd, $reviewgraph, $width, $height, $bgcolor));
}
function last_watched_on($param) {
global $dvd, $DVD_EVENTS_TABLE, $watched, $db, $lang;
	print_param($param, array('NAME'));

	$sql = "SELECT UNIX_TIMESTAMP(timestamp) AS ts FROM $DVD_EVENTS_TABLE WHERE id='$dvd[id]' AND eventtype='$watched' ORDER BY timestamp DESC LIMIT 1";
	$res = $db->sql_query($sql) or die($db->sql_error());
	$row = $db->sql_fetchrow($res);
	$t = $row['ts'];
	$db->sql_freeresult($res);
	$ret = '';
	if ($t != '')
		$ret = strftime($lang['SKINDATEFORMAT'], $t);
	return($ret);
}
function last_watched_by($param) {
global $dvd, $DVD_EVENTS_TABLE, $watched, $db, $lang;
	print_param($param, array('NAME'));

	$sql = "SELECT firstname,lastname,timestamp FROM $DVD_EVENTS_TABLE WHERE id='$dvd[id]' AND eventtype='$watched' ORDER BY timestamp DESC";
	$res = $db->sql_query($sql) or die($db->sql_error());
	$ts = '';
	$ret = '';
	$divider = ", ";
	while ($row = $db->sql_fetchrow($res)) {
		if ($ts == '') $ts = $row['timestamp'];
		if ($row['timestamp'] != $ts)
			break;
		if ($ret != '') $ret .= $divider;
		$ret .= preg_replace('/\s\s+/', ' ', trim("$row[firstname] $row[lastname]"));
	}
	$db->sql_freeresult($res);
	return($ret);
}
function otherfeatures($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = $dvd['featureother'];
	return($ret);
}
function program_location($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = '.';
	return($ret);
}
function program_language($param) {
global $lang;
	print_param($param, array('NAME'));

	$ret = 'English';
	return($ret);
}
function program_build($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = '915';
	return($ret);
}
function program_version($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = "2.5.0";
	return($ret);
}
function discs($param) {
// DVDPro BUG - can't represent Not-DS + Flipper (Windows program should dis-allow)
global $dvd, $lang;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	$subdivider = ProcessAParameter($param, 'SUBDIVIDER', 'string', ' - ');
	if ($subdivider == 'BREAK') $subdivider = '<BR>';
	$showdescriptions = ProcessAParameter($param, 'SHOWDESCRIPTIONS', 'bool', false);
	$showlocations = ProcessAParameter($param, 'SHOWLOCATIONS', 'bool', false);
	$showslots = ProcessAParameter($param, 'SHOWSLOTS', 'bool', false);
	$showlabels = ProcessAParameter($param, 'SHOWLABELS', 'bool', false);
	$showsides = ProcessAParameter($param, 'SHOWSIDES', 'bool', false);
	$showlayers = ProcessAParameter($param, 'SHOWLAYERS', 'bool', false);
	$showdiscids = ProcessAParameter($param, 'SHOWDISCIDS', 'bool', false);
	print_param($param, array('NAME','DIVIDER','SUBDIVIDER','SHOWDESCRIPTIONS','SHOWLOCATIONS','SHOWSLOTS','SHOWLABELS','SHOWSIDES','SHOWLAYERS','SHOWDISCIDS'));

	$ret = '';
	foreach ($dvd['discs'] as $k => $d) {
		$line = '';
		if ($showdescriptions) {
			if ($line != '') $line .= $subdivider;
			$line .= $d['discdescsidea'].$d['discdescsideb'];
		}
		if ($showlocations) {
			if ($line != '') $line .= $subdivider;
			$line .= $d['location'];
		}
		if ($showslots) {
			if ($line != '') $line .= $subdivider;
			$line .= $d['slot'];
		}
		if ($showdiscids) {
			if ($line != '') $line .= $subdivider;
			$line .= $d['discidsidea'];
			if ($d['discidsideb'] != '')
				$line .= ", $d[discidsideb]";
		}
		if ($showlabels) {
			if ($line != '') $line .= $subdivider;
			$line .= $d['labelsidea'];
			if ($d['labelsideb'] != '')
				$line .= ", $d[labelsideb]";
		}
		if ($showsides) {
			if ($line != '') $line .= $subdivider;
			$line .= (($d['dualsided']==1)?$lang['DUALSIDED']:$lang['SINGLESIDED']);
		}
		if ($showlayers) {
			if ($line != '') $line .= $subdivider;
			$line .= (($d['duallayeredsidea']==1)?$lang['DUALLAYERED']:$lang['SINGLELAYERED']);
		}
		if ($ret != '') $ret .= $divider;
		$ret .= $line;
	}
	return($ret);
}
function eastereggs($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = $dvd['eastereggs'];
	return($ret);
}
function notes($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = $dvd['notes'];
	return($ret);
}
function subtitles($param) {
global $dvd;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	print_param($param, array('NAME','DIVIDER'));

	$ret = '';
	foreach ($dvd['subtitles'] as $k => $s)
		$ret .= $s.$divider;
	$ret = substr($ret, 0, -1*strlen($divider));
	return($ret);
}
function audiotracks($param) {
global $dvd, $achan_rev_translation;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	print_param($param, array('NAME','DIVIDER'));

	$ret = '';
	foreach ($dvd['audio'] as $k => $a) {
		$l = $a['audiocontent'];
		$n = $a['audioformat'];
		$ret .= "$l: $n$divider";
	}
	$ret = substr($ret, 0, -1*strlen($divider));
	return($ret);
}
function casetype($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = $dvd['casetype'];
	return($ret);
}
function vid16x9($param) {
global $dvd;
	$text = ProcessAParameter($param, 'TEXT', 'string', 'Anamorphic');
	print_param($param, array('NAME','TEXT'));

	$ret = '';
	if ($dvd['format16x9'] == 1)
		$ret = $text;
	return($ret);
}
function vidstandard($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = $dvd['formatvideostandard'];
	return($ret);
}
function vidformats($param) {
global $dvd, $lang;
	$maxlist = ProcessAParameter($param, 'MAXLIST', 'int', 0);
	$ratios = ProcessAParameter($param, 'RATIOS', 'bool', false);
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	print_param($param, array('NAME','DIVIDER','RATIOS','MAXLIST'));

	$ret = '';
	$count = 0;
	if ($dvd['formatletterbox'] == 1) {
		$ret = '<NOBR>';
		if ($dvd['format16x9'] == 1)
			$ret .= $lang['16X9'].' ';
		$ret .= $lang['WIDESCREEN'];
		if ($ratios)
			$ret .= " $dvd[formataspectratio]:1";
		$ret .= '</NOBR>';
		$count++;
	}
	if ($count == 1 && $maxlist >= 1)
		return($ret);
	if ($ret == '') $divider = '';
	if ($dvd['formatpanandscan'] == 1)
		$ret .= "$divider<NOBR>$lang[PANANDSCAN] 1.33:1</NOBR>";
	if ($dvd['formatfullframe'] == 1)
		$ret .= "$divider<NOBR>$lang[FULLFRAME] 1.33:1</NOBR>";
	return($ret);
}
function regions($param) {
global $dvd;
// PREFIX is not affixed if region == 0
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	$noregion = ProcessAParameter($param, 'NOREGION', 'string', 'Region 0');
	print_param($param, array('NAME','PREFIX','NOREGION'));

	$ret = '';
	for ($i=0; $i<strlen($dvd['region']); $i++) {
		if ($ret != '') $ret .= ', ';
		$ret .= $dvd['region']{$i};
	}
	unset($tmp);
	if ($ret != '' && $ret != '0') $ret = $prefix.$ret;
	if ($ret == '0') $ret = $noregion;
	return($ret);
}
function region($param) {
global $dvd;
	$text = ProcessAParameter($param, 'TEXT', 'string', '');
	$noregion = ProcessAParameter($param, 'NOREGION', 'string', 'Region 0');
	print_param($param, array('NAME','NOREGION','TEXT'));

	$ret = substr($dvd['region'], 0, 1);
	if ($ret == '0') $ret = $noregion;
	$ret = $text.$ret;
	return($ret);
}
function layers($param) {
global $dvd, $lang;
	$single = ProcessAParameter($param, 'SINGLE', 'string', $lang['SINGLELAYERED']);
	$dual = ProcessAParameter($param, 'DUAL', 'string', $lang['DUALLAYERED']);
	print_param($param, array('NAME','SINGLE','DUAL'));

	if ($dvd['formatduallayered'] == 1)
		$ret = $dual;
	else
		$ret = $single;
	return($ret);
}
function sides($param) {
global $dvd, $lang;
	$single = ProcessAParameter($param, 'SINGLE', 'string', $lang['SINGLESIDED']);
	$dual = ProcessAParameter($param, 'DUAL', 'string', $lang['DUALSIDED']);
//	$flipper = ProcessAParameter($param, 'FLIPPER', 'string', $lang['FLIPPER']);
	print_param($param, array('NAME','SINGLE','DUAL','FLIPPER'));

//	if ($dvd['formatflipper'] == 1)
//		$ret = $flipper;
//	else
	if ($dvd['formatdualsided'] == 1)
		$ret = $dual;
	else
		$ret = $single;
	return($ret);
}
function srp($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = "$dvd[srp] $dvd[srpcurrencyid]";
	return($ret);
}
function studios($param) {
global $dvd;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	print_param($param, array('NAME','DIVIDER'));

	$ret = '';
	foreach ($dvd['studios'] as $k =>$s) {
		if ($ret != '') $ret .= $divider;
		$ret .= "<NOBR><NOBR>$s</NOBR></NOBR>";
	}
	return($ret);
}
function runtime($param) {
global $dvd;
	$hoursonly = ProcessAParameter($param, 'HOURSONLY', 'bool', false);
	$minsonly = ProcessAParameter($param, 'MINSONLY', 'bool', false);
	$totalinmins = ProcessAParameter($param, 'TOTALINMINS', 'bool', false);
	print_param($param, array('NAME','HOURSONLY','MINSONLY','TOTALINMINS'));

	$mins = $dvd['runningtime']%60;
	$hours = floor($dvd['runningtime']/60);
	if ($hoursonly) {
		$ret = $hours;
	}
	else if ($minsonly) {
		$ret = $mins;
	}
	else if ($totalinmins) {
		$ret = $dvd['runningtime'];
	}
	else {
		if ($mins < 10) $mins = '0'.$mins;
		$ret = "$hours:$mins";
	}
	return($ret);
}
function purchdate($param) {
global $dvd, $lang;
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	print_param($param, array('NAME','PREFIX'));

	$ret = $prefix.ucwords(strftime($lang['SKINDATEFORMAT'], $dvd['purchasedate']));
	return($ret);
}
function purchplace($param) {
global $dvd, $supplier;
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	print_param($param, array('NAME','PREFIX'));

// incupdate.php sets missing value into mysql as 'Unknown'
	if ($supplier === false)
		return('');
	$ret = "$prefix$supplier[suppliername]";
	return($ret);
}
function purchprice($param) {
global $dvd;
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	print_param($param, array('NAME','PREFIX'));

	$ret = $prefix.$dvd['purchaseprice'];
	return($ret);
}
function overview($param) {
global $dvd;
	print_param($param, array('NAME'));
// The import into MySQL somehow changes &#13;&#10; into \r instead of \r\n. Since we are putting \r\n into
// the output, DON't use an array of all the combinations here, or you'll get nonsense.
	$ret = str_replace("\r", "<BR>\r\n", $dvd['overview']);
	return($ret);
}
function image($param) {
global $dvd, $maxthumbwidth;
	$width = ProcessAParameter($param, 'WIDTH', 'int', 160);
	$doback = (strcasecmp(ProcessAParameter($param, 'FACE', 'string', 'front'), 'back') == 0);
	print_param($param, array('NAME','WIDTH','FACE'));

	$postfix = '';
	if ($doback) {
		if ($dvd['backimageanchor'] != '')
			$postfix = '</a>';
		$xxx = $dvd['backimage'];
		if ($width <= $maxthumbwidth || $xxx == '')
			$xxx = $dvd['backthumb'];
		$ret = "$dvd[backimageanchor]<IMG SRC=\"$xxx\" WIDTH=$width>$postfix";
	}
	else {
		if ($dvd['frontimageanchor'] != '')
			$postfix = '</a>';
		$xxx = $dvd['frontimage'];
		if ($width <= $maxthumbwidth || $xxx == '')
			$xxx = $dvd['frontthumb'];
		$ret = "$dvd[frontimageanchor]<IMG SRC=\"$xxx\" WIDTH=$width>$postfix";
	}
	return($ret);
}
function rating($param) {
global $dvd;
	print_param($param, array('NAME'));

	$ret = $dvd['rating'];
	return($ret);
}
function genres($param) {
global $dvd;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	print_param($param, array('NAME','DIVIDER'));

	$tmp = explode('<br>', $dvd['genres']);
	$ret = '';
	foreach ($tmp as $k =>$v) {
		if ($ret != '') $ret .= $divider;
		$ret .= "<NOBR><NOBR>$v</NOBR></NOBR>";
	}
	return($ret);
}
function directors($param) {
global $dvd, $colornames, $lang;
	$maxlist = ProcessAParameter($param, 'MAXLIST', 'int', 0);
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	$suffix = ProcessAParameter($param, 'SUFFIX', 'string', '');
	$showroles = ProcessAParameter($param, 'SHOWROLES', 'bool', false);
	$roledivider = ProcessAParameter($param, 'ROLEDIVIDER', 'string', '...');
	$cn = ProcessAParameter($param, 'COLORNAMES', 'bool', $colornames);
	$rolesfirst = ProcessAParameter($param, 'ROLESFIRST', 'bool', false);
	print_param($param, array('NAME','MAXLIST','DIVIDER','PREFIX','SUFFIX','SHOWROLES','ROLEDIVIDER','COLORNAMES','ROLESFIRST'));

	$ret = '';
	$count = 0;
	foreach ($dvd['directors'] as $k => $d) {
		$count++;
		if ($maxlist != 0 && $count>$maxlist)
			break;
		$d['creditsubtype'] = $lang[strtoupper(str_replace(' ','',$d['creditsubtype']))];
		$dirname = "<A href=\"javascript:;\" onClick=\"$d[oc]\">".ColorName($d, $cn, true).'</A>';
		if ($k != 0)
			$ret .= $divider;
		if ($showroles) {
			if ($rolesfirst)
				$ret .= $d['creditsubtype'].$roledivider.$dirname;
			else
				$ret .= $dirname.$roledivider.$d['creditsubtype'];
		}
		else
			$ret .= $dirname;
	}
	if ($ret != '')
		$ret = ($prefix.$ret.$suffix);
	return($ret);
}
function director($param) {
	return(directors($param));
}
function prodyear($param) {
global $dvd;
	$blank = ProcessAParameter($param, 'BLANK', 'string', '');
	print_param($param, array('NAME','BLANK'));

	$ret = $dvd['productionyear'];
	if ($ret == '') $ret = $blank;
	return($ret);
}
function lock($param) {
global $dvd, $locks;
	$ifset = ProcessAParameter($param, 'IFSET', 'string', 'Locked');
	$ifnotset = ProcessAParameter($param, 'IFNOTSET', 'string', '');
	print_param($param, array('NAME','IFSET','IFNOTSET'));

	$d = strtolower(substr($param['NAME'], 5));
	if ($d == 'audiotracks') $d = 'audio';
	if ($d == 'coverimages') $d = 'covers';
	$ret = $ifset;
	if ($locks[$d] == '')
		$ret = $ifnotset;
	return($ret);
}
function features($param) {
global $dvd, $bullet;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	print_param($param, array('NAME','DIVIDER'));

	$ret = '<NOBR>';
	$sep = "</NOBR>$divider<NOBR>";
	foreach ($dvd['extras'] as $val) {
		$ret .= $val.$sep;
	}
	$ret = substr($ret, 0, -1*(strlen($sep)-7));
	return($ret);
}
function boxsetcontents($param) {
global $dvd, $DVD_TABLE, $db;
	$showupcs = ProcessAParameter($param, 'SHOWUPCS', 'bool', false);
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	print_param($param, array('NAME','SHOWUPCS','DIVIDER'));

	$ret = '';
	if ($dvd['boxchild'] == 0)
		return($ret);

	$sql = "SELECT title,upc from $DVD_TABLE WHERE boxparent='$dvd[id]' ORDER BY id";
	$res = $db->sql_query($sql) or die($db->sql_error());
	while ($row = $db->sql_fetchrow($res)) {
		$t = $row['title'];
		if ($showupcs)
			$t .= " ($row[upc])";
		if ($ret != '') $ret .= $divider;
		$ret .= "<NOBR>$t</NOBR>";
	}
	$db->sql_freeresult($res);
	return($ret);
}
function upc($param) {
global $dvd;
	$formatted = ProcessAParameter($param, 'FORMATTED', 'bool', true);
	print_param($param, array('NAME','FORMATTED'));

	if ($formatted)
		$ret = $dvd['upc'];
	else
		$ret = $dvd['id'];
	return($ret);
}
function reldate($param) {
global $dvd, $lang;
	$blank = ProcessAParameter($param, 'BLANK', 'string', '');
	$yearonly = ProcessAParameter($param, 'YEARONLY', 'bool', false);
	$yeardigits = ProcessAParameter($param, 'YEARDIGITS', 'string', '2');
	print_param($param, array('NAME','BLANK','YEARONLY','YEARDIGITS'));

	if ($dvd['released'] == '')
		return($blank);
	if ($yearonly) {
		$ret = ucwords(strftime(($yeardigits=='4'?"%Y":"%y"), $dvd['released']));
	}
	else {
		$ret = ucwords(strftime($lang['SKINDATEFORMAT'], $dvd['released']));
	}
	return($ret);
}
function locality($param) {
global $dvd, $lang;
	print_param($param, array('NAME'));

	$locale = substr(strstr($dvd['id'], '.'), 1, 2);
	if (!$locale) $locale = '0';
	$ret = $lang['LOCALE'.$locale];
	return($ret);
}
// SETTINGS is an extension
function settings($param) {
global $dvd, $lang, $VersionNum, $IsPrivate, $SeparateReviews;
global $reviewgraph, $reviewsort;

	print_param($param, array('NAME'));

	$ret = '';
	$ret .= "VersionNum=$VersionNum\n";
	$ret .= 'IsPrivate='.($IsPrivate?'true':'false')."\n";
	$ret .= 'SeparateReviews='.($SeparateReviews?'true':'false')."\n";
	$ret .= "reviewgraph=$reviewgraph\n";
	$ret .= "reviewsort=$reviewsort\n";
	$ret = substr($ret, 0, strlen($ret)-1);
	return($ret);
}
// TAGS is an extension
function tags($param) {
global $dvd;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	$suffix = ProcessAParameter($param, 'SUFFIX', 'string', '');
	$separator = ProcessAParameter($param, 'SEPARATOR', 'string', '...');
	$showid = ProcessAParameter($param, 'SHOWID', 'bool', false);
	$showname = ProcessAParameter($param, 'SHOWNAME', 'bool', false);
	$showfullyqualifiedname = ProcessAParameter($param, 'SHOWFULLYQUALIFIEDNAME', 'bool', true);
	print_param($param, array('NAME','DIVIDER','PREFIX','SUFFIX','SEPARATOR','SHOWID','SHOWNAME','SHOWFULLYQUALIFIEDNAME'));

	$ret = '';
	foreach ($dvd['tags'] as $k => $t) {
		if ($ret != '') $ret .= $divider;
		$line = '';
		if ($showid) {
			if ($line != '') $line .= $separator;
			$line .= $t['id'];
		}
		if ($showname) {
			if ($line != '') $line .= $separator;
			$line .= $t['name'];
		}
		if ($showfullyqualifiedname) {
			if ($line != '') $line .= $separator;
			$line .= $t['fullyqualifiedname'];
		}
		$ret .= $line;
	}
	if ($ret != '')
		$ret = $prefix.$ret.$suffix;
	return($ret);
}
// EVENTS is an extension
function events($param) {
global $dvd, $lang;
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	$suffix = ProcessAParameter($param, 'SUFFIX', 'string', '');
	$separator = ProcessAParameter($param, 'SEPARATOR', 'string', '...');
	$showfullname = ProcessAParameter($param, 'SHOWFULLNAME', 'bool', false);
	$showfirstname = ProcessAParameter($param, 'SHOWFIRSTNAME', 'bool', true);
	$showlastname = ProcessAParameter($param, 'SHOWLASTNAME', 'bool', true);
	$showphonenumber = ProcessAParameter($param, 'SHOWPHONENUMBER', 'bool', true);
	$showemailaddress = ProcessAParameter($param, 'SHOWEMAILADDRESS', 'bool', true);
	$showeventtype = ProcessAParameter($param, 'SHOWEVENTTYPE', 'bool', true);
	$showtimestamp = ProcessAParameter($param, 'SHOWTIMESTAMP', 'bool', true);
	print_param($param, array('NAME','DIVIDER','PREFIX','SUFFIX','SEPARATOR','SHOWFULLNAME','SHOWFIRSTNAME','SHOWLASTNAME','SHOWPHONENUMBER','SHOWEMAILADDRESS','SHOWEVENTTYPE','SHOWTIMESTAMP'));

	$ret = '';
	foreach ($dvd['events'] as $k => $e) {
		if ($ret != '') $ret .= $divider;
		$line = '';
		if ($showfullname) {
			if ($line != '') $line .= $separator;
			$line .= "$e[firstname] $e[lastname]";
		}
		if ($showfirstname) {
			if ($line != '') $line .= $separator;
			$line .= $e['firstname'];
		}
		if ($showlastname) {
			if ($line != '') $line .= $separator;
			$line .= $e['lastname'];
		}
		if ($showphonenumber) {
			if ($line != '') $line .= $separator;
			$line .= $e['phonenumber'];
		}
		if ($showemailaddress) {
			if ($line != '') $line .= $separator;
			$line .= $e['emailaddress'];
		}
		if ($showeventtype) {
			if ($line != '') $line .= $separator;
			$line .= $e['eventtype'];
		}
		if ($showtimestamp) {
			if ($line != '') $line .= $separator;
			$line .= $e['timestamp'];
		}
		$ret .= $line;
	}
	if ($ret != '')
		$ret = $prefix.$ret.$suffix;
	return($ret);
}
function collnum($param) {
global $dvd, $lang;
// SHOWWISHLISTPRIORITY is an extension
	$showwishlistpriority = ProcessAParameter($param, 'SHOWWISHLISTPRIORITY', 'bool', false);
	print_param($param, array('NAME','SHOWWISHLISTPRIORITY'));

	$ret = $dvd['collectionnumber'];
	if ($showwishlistpriority && $dvd['collectiontype'] == 'wishlist')
		$ret = $lang['WISHNAME'.$dvd['wishpriority']];
	return($ret);
}
function crew($param) {
global $dvd, $colornames, $lang;
	$gottafind = '';
	switch ($param['NAME']) {
	case 'CREW_DIRECTION':
	case 'CREDITS_DIRECTION':
		return(directors($param));
	case 'CREW_ART':
	case 'CREDITS_ART':
		$gottafind = 'Art';
		break;
	case 'CREW_CINEMATOGRAPHY':
	case 'CREDITS_CINEMATOGRAPHY':
		$gottafind = 'Cinematography';
		break;
	case 'CREW_FILMEDITING':
	case 'CREDITS_FILMEDITING':
		$gottafind = 'Film Editing';
		break;
	case 'CREW_MUSIC':
	case 'CREDITS_MUSIC':
		$gottafind = 'Music';
		break;
	case 'CREW_PRODUCTION':
	case 'CREDITS_PRODUCTION':
		$gottafind = 'Production';
		break;
	case 'CREW_SOUND':
	case 'CREDITS_SOUND':
		$gottafind = 'Sound';
		break;
	case 'CREW_WRITING':
	case 'CREDITS_WRITING':
		$gottafind = 'Writing';
		break;
	}
	$maxlist = ProcessAParameter($param, 'MAXLIST', 'int', 0);
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	$prefix = ProcessAParameter($param, 'PREFIX', 'string', '');
	$suffix = ProcessAParameter($param, 'SUFFIX', 'string', '');
	$showroles = ProcessAParameter($param, 'SHOWROLES', 'bool', false);
	$roledivider = ProcessAParameter($param, 'ROLEDIVIDER', 'string', '...');
	$cn = ProcessAParameter($param, 'COLORNAMES', 'bool', $colornames);
	$rolesfirst = ProcessAParameter($param, 'ROLESFIRST', 'bool', false);
	print_param($param, array('NAME','MAXLIST','DIVIDER','PREFIX','SUFFIX','SHOWROLES','ROLEDIVIDER','COLORNAMES','ROLESFIRST'));

	$ret = '';
	$count = 0;
	foreach ($dvd['credits'] as $k => $c) {
		if ($c['credittype'] != $gottafind)
			continue;
		$count++;
		if ($maxlist != 0 && $count>$maxlist)
			break;
		$c['creditsubtype'] = $lang[strtoupper(str_replace(' ','',$c['creditsubtype']))];
		$dirname = "<A href=\"javascript:;\" onClick=\"$c[oc]\">".ColorName($c, $cn, true).'</A>';
		if ($ret != '') $ret .= $divider;
		if ($showroles) {
			if ($rolesfirst)
				$ret .= $c['creditsubtype'].$roledivider.$dirname;
			else
				$ret .= $dirname.$roledivider.$c['creditsubtype'];
		}
		else
			$ret .= $dirname;
	}
	if ($ret != '')
		$ret = ($prefix.$ret.$suffix);
	return($ret);
}
function actors($param) {
global $dvd, $colornames;
	$maxlist = ProcessAParameter($param, 'MAXLIST', 'int', 0);
	$divider = ProcessAParameter($param, 'DIVIDER', 'string', ', ');
	if ($divider == 'BREAK') $divider = '<BR>';
	$showroles = ProcessAParameter($param, 'SHOWROLES', 'bool', false);
	$roledivider = ProcessAParameter($param, 'ROLEDIVIDER', 'string', ' as ');
	$cn = ProcessAParameter($param, 'COLORNAMES', 'bool', $colornames);
	$rolesfirst = ProcessAParameter($param, 'ROLESFIRST', 'bool', false);
	$roledivifblank = ProcessAParameter($param, 'ROLEDIVIFBLANK', 'bool', false);
	print_param($param, array('NAME','MAXLIST','DIVIDER','SHOWROLES','ROLEDIVIDER','COLORNAMES','ROLESFIRST','ROLEDIVIFBLANK'));

	$ret = '';
	$count = 0;
	foreach ($dvd['actors'] as $k => $a) {
		$count++;
		if ($maxlist != 0 && $count>$maxlist)
			break;
		if ($k != 0)
			$ret .= '</NOBR>'.$divider.'<NOBR>';
		$dirname = "<A href=\"javascript:;\" onClick=\"$a[oc]\">".ColorName($a, $cn, true).'</A>';
		if ($showroles) {
			$rd = $roledivider;
			if ($a['role'] == '' && !$roledivifblank) $rd = '';
			if ($rolesfirst)
				$ret .= $a['role'].$rd.$dirname;
			else
				$ret .= $dirname.$rd.$a['role'];
		}
		else
			$ret .= $dirname;
	}
	if ($ret != '') $ret .= '</NOBR>';
	return($ret);
}
function cast($param) {
	return(actors($param));
}

function ProcessDP($matches) {
global $debugskin;

//	if (stristr($matches[0], 'ACTORS') !== false) {echo "<pre>matches = ";print_r($matches);echo "</pre><br>";}
	$tmp = explode('"', $matches[3]);
//	if (stristr($matches[0], 'ACTORS') !== false) {echo "<pre>tmp = ";print_r($tmp);echo "</pre><br>";}
	for ($i=0; $i<count($tmp)-1; ) {
/////		$arr[] = trim($tmp[$i]).'"'.trim($tmp[$i+1]).'"'; // This messes up " as ". Not doing it may break something else ...
		$arr[] = trim($tmp[$i]).'"'.$tmp[$i+1].'"';
		$i += 2;
	}
//	if (stristr($matches[0], 'RUNTIME') !== false) {echo "<pre>arr = ";print_r($arr);echo "</pre><br>";}
	foreach ($arr as $v) {
		$split = $splite = strpos($v, '=');
		$splitq = strpos($v, '"');
		if ($splite === false || $splitq < $splite)
			$split = $splitq;
		$param[strtoupper(substr($v, 0, $split))] = trim(substr($v, $split+1), '"');
	}
	unset($arr);
//	if (stristr($matches[0], 'RUNTIME') !== false) {echo "<pre>param = ";print_r($param);echo "</pre><br>";}
	$t = $param['NAME'];
	if ($t == '16X9')
		$t = 'VID16X9';
	if (strncmp($t, 'LOCK_', 5) == 0) $t = 'LOCK';
	if (strncmp($t, 'CREW_', 5) == 0) $t = 'CREW';
	if (strncmp($t, 'CREDITS_', 8) == 0) $t = 'CREW';
	if (function_exists($t))
		$result = $t($param);
	else {
		$result = '';
		if ($debugskin)
			echo "Unrecognised call: &lt;DP NAME=\"$t\"&gt;<br>";
	}
	return($matches[1].$result);
}

function Replace2Lang($matches) {
global $lang;
	$matches[1] = str_replace("'", '', $matches[1]);
	$matches[1] = str_replace('"', '', $matches[1]);
	$matches[2] = str_replace("'", '', $matches[2]);
	$matches[2] = str_replace('"', '', $matches[2]);
	return($lang[$matches[1]][$matches[2]]);
}
function ReplaceLang($matches) {
global $lang;
	$matches[1] = str_replace("'", '', $matches[1]);
	$matches[1] = str_replace('"', '', $matches[1]);
	return($lang[$matches[1]]);
}

if (is_readable("$skinloc/$skinfile")) {
	$skin = file_get_contents("$skinloc/$skinfile");
	$j = preg_replace_callback('/(.*)(<DP )([^>"]*(("[^"]*")[^>"]*)*)(>)(.*)/Ui', "ProcessDP", $skin);
	unset($skin);

	$j = preg_replace_callback('/\\$lang\\[(.*)\\]\\[(.*)\\]/U', "Replace2Lang", $j);
	$j = preg_replace_callback('/\\$lang\\[(.*)\\]/U', "ReplaceLang", $j);

	$j = preg_replace('|\\.\\.[\\\\/]\\.\\.[\\\\/]skins[\\\\/]temp[\\\\/]|i', $skinloc.'/', $j);
	$j = str_replace('$DPIMAGES.', $skinloc.'/', $j);
	$j = preg_replace('|</body>|i', $endbody, $j);
	echo $j;
	DebugSQL($db, "skin($skinloc/$skinfile)");
	exit;		// don't fall through: falling through does the internal skin
}
?>
